// Multi-line Advertisements script by fri (http://tehoko.info), updated version
// uses Explode function by CurryWurst and Curt (DorkeyDear)

const
	AdsFile  = 'scripts/ads/ads.txt';  // file with advertisements. default: 'scripts/ads/ads.txt'
	Interval = 300;                    // seconds between ads displays. default: 300 (5 minutes)
	Breaker  = '\n';                   // this sequence of characters will break an advertisement there into another line. default: '\n'
	Color    = $FFAAFFAA;              // color of text. default: $FFAAFFAA (green)

var
	active: boolean;
	rotation: array of string;
	adcount, lastshown: shortint;
	countdown: integer;

function readfromfile(name: string): string;
	begin
		result := readfile ( name );
		result := copy ( result, 0, length ( result ) - 2 );
	end;

function xfileexists(name: string): boolean;
	begin
		result := false;
		if lowercase ( getsystem ( ) ) = 'windows' then begin
			if fileexists ( name ) then result := true;
		end else
			if ( fileexists ( name ) ) or ( readfromfile ( name ) <> '' ) then result := true;
	end;

procedure msg(id: byte; text: string; color: word);
	begin
		if ( id = 255 ) then writeln ( 'ads>  ' + text )
		else writeconsole ( id, text, color );
	end;

function explode(source: string; const delimiter: string): array of string;
	var
		position, dellength, reslength: integer;
	begin
		dellength := length ( delimiter );
		source := source + delimiter;
		repeat
			position := pos ( delimiter, source );
			setarraylength ( result, reslength + 1 );
			result [ reslength ] := copy ( source, 1, position - 1 );
			reslength := reslength + 1;
			delete ( source, 1, position + dellength - 1 );
		until ( position = 0 );
		setarraylength ( result, reslength - 1 );
	end;

function loadAds: boolean;
	begin
		result := false;
		if xfileexists ( AdsFile ) then begin
			result := true;
			rotation := explode ( readfile ( AdsFile ), chr(13) + chr(10) );
			adcount := arrayhigh ( rotation );
			lastshown := 0;
			countdown := Interval;
		end;
	end;

procedure showInfo;
	begin
		writeconsole ( 0, 'Current map: ' + CurrentMap, Color );
		writeconsole ( 0, 'Next map:    ' + NextMap, Color );
		writeconsole ( 0, 'Time left:   ' + iif ( TimeLeft >= 60, inttostr ( TimeLeft div 60 ) + ' min ', '' ) + iif ( ( TimeLeft mod 60 ) <> 0, inttostr ( TimeLeft mod 60 ) + ' seconds', '' ), Color );
		writeconsole ( 0, 'Server time: ' + formatdate ( 'hh:nn:ss' ), Color );
	end;

procedure activateserver();
	begin
		active := loadAds;
	end;

procedure apponidle(ticks: integer);
	var 
		temp: tstringarray;
		i: byte;
	begin
		if active then begin
			if countdown = 0 then begin
				lastshown := lastshown + 1;
				if lastshown >= adcount then lastshown := 1;
				if lowercase ( rotation [ lastshown ] ) = 'info' then begin
					showInfo;
					writeln ( 'ads>  Shown basic info (ad no. ' + inttostr ( lastshown ) + ' = ''info'').' );
					countdown := Interval - 1;
					exit;
				end;
				temp := explode ( rotation [ lastshown ], Breaker ); // divide single line into a few...
				for i := 0 to arrayhigh ( temp ) do
					writeconsole ( 0, temp [ i ], Color ); // ...and show each of them separately
				writeln ( 'ads>  Shown advertisement no. ' + inttostr ( lastshown ) + '.' );
				countdown := Interval;
			end;
			if countdown > 0 then countdown := countdown - 1;
		end;
	end;

function oncommand(id: byte; text: string): boolean;
	begin
		if lowercase ( text ) = '/loadad' then begin
			active := loadAds;
			if active then
				msg ( id, 'Advertisements file reloaded (' + inttostr ( adcount ) + iif ( adcount = 1, ' ad', ' ads' ) + ', interval = ' + inttostr ( Interval ) + ' s).', Color )
			else
				msg ( id, 'Error: advertisements couldn''t be reloaded.', $FFFFAAAA );
		end;
		result := false;
	end;